#ifndef MAINWINDOW_H
#define MAINWINDOW_H
#include <QDebug>
#include <list>
#include <time.h>
#if QT_VERSION < QT_VERSION_CHECK(5,0,0)
#include <QMainWindow>
#include <QtGui/QApplication>
#else
#include <QtWidgets>
#include <QApplication>
#endif

#include "lib/iboolean.h"
#include "lib/interval.h"
#include "lib/box.h"
#include "lib/repere.h"

#include "sivia.h"



namespace Ui {
    class MainWindow;
}

class MainWindow : public QMainWindow
{
    Q_OBJECT


public:
    explicit MainWindow(QWidget *parent = 0);
    ~MainWindow();
    void Init();
    void SIVIA(void (*C)(box& X),box X0);


    void drawRobotArticuler(double a1, double a2);
private:
    Ui::MainWindow *ui;
    repere *Rworld;
    Sivia *sivia;

    vector<double> L_a1;
    vector<double> L_a2;


signals:

public slots:
    void drawArtRobot(double a1, double a2);
    void addPoint(double a1, double a2, bool add);
private slots:
    void on_ButtonStart_clicked();
    void on_SaveImages_clicked();
};



#endif // MAINWINDOW_H
