#ifndef SIVIA_H
#define SIVIA_H

// intervalles librairies
#include "lib/box.h"
#include "lib/interval.h"
#include "lib/iboolean.h"

// librarie Dessin
#include "lib/repere.h"
#include <lib/msimpledrawer.h>

// Timer pour faire des statistiaus
#include <QElapsedTimer>

// hyperbox header
#include "hyperbox.h"

class Sivia
{
    typedef void (Sivia::*Separator)(box& X,bool outer);
public:
    Sivia(mSimpleDrawer *R, double epsilon = 0.3);
    ~Sivia();


    void runSivia(Separator S, box X0, double epsilon);
    box fixPoint(Separator S, box &X, box &Xin, box &Xout);
    void SIVIA(Separator S, HyperBox *H0);
    void reduceNode(HyperBox *H0);
    void separateur(box &X, bool outer);

    void drawTree(HyperBox *H0);

    void clearStats();
    void printStats();


protected:
    mSimpleDrawer *R;
    double epsilon;

    int nb_sep_call;
    int nb_box;
    int nb_emptyBox;
    int nb_yellow;
    int exec_time;
    int casNonTraite;
    int nbInBox;
    int nbOutBox;
    int nbYellowBox;
    int nbBoxTotal;
    int remainingEmpty;

    HyperBox *H0;
};

#endif // SIVIA_H
